// C Header File
// Created 10/9/2003; 4:17:21 PM

#define checkAPD()       //if(OSTimerExpired(APD_TIMER)){off();OSTimerRestart(APD_TIMER);}
#define clearPanel(option) DrawColorRect(98,option,157,97,COLOR_WHITE,RECT_FILLED)
// DEREFSMALL(p,i) is (mainly) the same things as p[ i ], but more optimized
#define DEREFSMALL(__p,__i) (*((typeof(&*__p))((unsigned char*)(__p)+(long)(short)((short)(__i)*sizeof(*(__p))))))

#define english          1
#define french           2
#define spanish          3
#define german           4

#define RIGHT_PANEL      127//129

#define COLOR_WHITE      0
#define COLOR_LIGHTGRAY  1
#define COLOR_DARKGRAY   2
#define COLOR_BLACK      3
#define INVERSE          4
#define INVERSE_BLACK    4
#define INVERSE_LIGHT    5
#define INVERSE_DARK     6

#define RECT_EMPTY       0
#define RECT_FILLED      1

#define OPTION_ROLL      1
#define OPTION_STATS     2
#define OPTION_TRADE     3
#define OPTION_PROPERTY  4
#define OPTION_FORFEIT   5
#define OPTION_SAVE      6

#define OPTION_BUY_IT    1
#define OPTION_LEAVE_IT  2
#define OPTION_INFO      3

#define OPTION_PLAYERS   1
#define OPTION_PLAYGAME  7

#define OPTION_1         1
#define OPTION_2         2
#define OPTION_3         3
#define OPTION_4         4
#define OPTION_5         5
#define OPTION_6         6
#define OPTION_7         7
#define OPTION_8         8

#define OPTION_LEFT      9
#define OPTION_RIGHT     10
#define OPTION_ESC       11
#define OPTION_HOME      12

#define NEW_GAME         0
#define LOAD_GAME        1

#define DONT_USE_LR      0
#define USE_LR           1

#define DONT_SCROLL      0
#define SCROLL_BOARD     1

#define FULL             2
#define BOTTOM           31

#define STANDARD         12
#define WIDESCREEN       20

// These next declarations are my way of using less variables while making it easier
// They are just substituted names
#define agreedToTrade keyPressed

void ClipSprite16_XOR_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),
register unsigned short *sprt asm("%a1"),register void *dest asm("%a0"));

void Sprite32_mask(short x,short y,short h,unsigned long* sprite_L,unsigned long* sprite_D) {
	Sprite32(x,y,h,sprite_L,GetPlane(LIGHT_PLANE),SPRT_OR);
	Sprite32(x,y,h,sprite_L,GetPlane(LIGHT_PLANE),SPRT_AND);
	Sprite32(x,y,h,sprite_D,GetPlane(DARK_PLANE),SPRT_OR);
	Sprite32(x,y,h,sprite_D,GetPlane(DARK_PLANE),SPRT_AND);
}

void DrawColorRect(short x0,short y0,short x1, short y1, short color,enum Bool fill) {
    WIN_RECT wrect;
    SCR_RECT rect;
    void     (*df)(void*,void*,short);
    void*    parea;

    if (fill) {
        rect.xy.x0 = x0;
        rect.xy.y0 = y0;
        rect.xy.x1 = x1;
        rect.xy.y1 = y1;
        parea      = &rect;
        df         = (void(*)(void*,void*,short))ScrRectFill;
    }
    else {
        wrect.x0 = x0;
        wrect.y0 = y0;
        wrect.x1 = x1;
        wrect.y1 = y1;
        parea    = &wrect;
        df       = (void(*)(void*,void*,short))DrawClipRect;
    }

  SetPlane(LIGHT_PLANE);
  if(color == INVERSE || color == INVERSE_LIGHT)
    (*df)(parea,&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
  else if(color != INVERSE_DARK) {
    if(color == COLOR_WHITE || color == COLOR_DARKGRAY)
      (*df)(parea,&(SCR_RECT){{0, 0, 159, 99}}, A_REVERSE);
    else
      (*df)(parea,&(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
  }

  SetPlane(DARK_PLANE);
  if(color == INVERSE || color == INVERSE_DARK)
    (*df)(parea,&(SCR_RECT){{0, 0, 159, 99}}, A_XOR);
  else if(color != INVERSE_LIGHT) {
    if (color == COLOR_WHITE || color == COLOR_LIGHTGRAY)
      (*df)(parea,&(SCR_RECT){{0, 0, 159, 99}}, A_REVERSE);
    else
      (*df)(parea,&(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
  }
}

void DrawPopup(short x0,short y0,short x1, short y1) {
	DrawColorRect(x0++,y0++,x1--,y1--,COLOR_BLACK,RECT_EMPTY);
	DrawColorRect(x0++,y0++,x1--,y1--,COLOR_DARKGRAY,RECT_EMPTY);
	DrawColorRect(x0++,y0++,x1--,y1--,COLOR_LIGHTGRAY,RECT_EMPTY);
	DrawColorRect(x0,y0,x1,y1,COLOR_WHITE,RECT_FILLED);
}

void Sprite16XOR(short x,short y,short h,unsigned short* sprite,void* dest) {
    register long            addr = (long)dest+(y<<5)-(y<<1)+((x>>3)&0x1e);
    register unsigned short  cnt  = 16-(x&15);
    for (;h;h--,addr+=30) *(long*)addr^=(long)((*sprite++) & 0xffff)<<cnt;
}

void DrawBlackStr(int x,int y,const char *string)
{
  GraySetAMSPlane(LIGHT_PLANE);
  DrawStr(x, y, string, A_NORMAL);
  GraySetAMSPlane(DARK_PLANE);
  DrawStr(x, y, string, A_NORMAL);
}

int BlackStrCentered(int centerPoint, int y, const char *string, short font)
{
	int width = DrawStrWidth(string, font);
	FontSetSys(font);
	DrawBlackStr(centerPoint - (int)(width >> 1), y, string);
	return width;
}

void __attribute__((__stkparm__)) ScrollUp160(unsigned short* buffer,unsigned short lines) {
	register short* dest = buffer;
	register short* src  = dest + 15;
	register short  tmplines = lines;
	tmplines -= 2;
	asm volatile ("0:\n"
		"move.l (%0)+,(%1)+;move.l (%0)+,(%1)+;move.l (%0)+,(%1)+\n"
		"move.l (%0)+,(%1)+;move.l (%0)+,(%1)+\n"
		"lea 10(%0),%0\n"
		"lea 10(%1),%1\n"
		"dbf %2,0b\n"
		"clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.l (%1)+;clr.l (%1)+"
		: "=a" (src), "=a" (dest), "=d" (tmplines)
		: "0"  (src),  "1" (dest), "2"  (tmplines));
}